This tool requires Isabelle 2018 (http://isabelle.in.tum.de/).

# Running Leviathan
To use the Leviathan tools, make a bash script using `isabelle/bash_script.cygwin` (for Windows) or `isabelle/bash_script.macosx` (for Mac/Linux) as a basis; source that script and then supply the `leviathan_all` alias with a filename to start the Isabelle editor with that file loaded in a Leviathan session (assuming you have downloaded Isabelle 2018 and added the binaries to your path, or have the path appended in the created bash scripts). The first time `leviathan_all` or a similar alias is run, Isabelle will build the Leviathan session; subsequent uses should load the stored session.
`leviathan_all` will use the `$LEVIATHAN` environment variable sourced from the script as its working directory.

If you encounter out-of-memory errors when building the Leviathan session, you may need to use 64-bit PolyML. To do so, create a `$HOME/.isabelle/Isabelle2018/etc/settings` file with the following contents:

```bash
ML_PLATFORM=$ISABELLE_PLATFORM64
ML_HOME=$POLYML_HOME/$ML_PLATFORM
ML_OPTIONS='-H 1000'
```

On Windows, the home variable would be `%USERPROFILE%` instead. (Or just use your home dir explicitly.)

# Ramblr
If you want to disassemble and work with your own binaries,
the wrapper scripts in `ramblr` can help with that;
the makefiles for the examples serve as guidelines for how to use them,
or you can run the scripts themselves if you want to.
The README in the `ramblr` folder provides more information on setup to use the scripts,
while `change_notes.md` in the examples folder documents manual fixes to the generated assembly
that may need to be made.
Any modern C compiler should work as we work off of the final binaries,
but different compilers may result in output assembly that differs from that generated by us.
