(*
Copyright 2018

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*)
theory Chum_Execution
  imports reassembly_manual_execution.Manual_Execution
begin

context execution_context
begin

primrec BV_ternary_operate :: "BV_ternary_operators \<Rightarrow> bv \<Rightarrow>  bv \<Rightarrow> bv \<Rightarrow> bv"
  where "BV_ternary_operate BV_Vfmsub132_Single bv1 bv2 bv3  = undefined"
|  "BV_ternary_operate BV_Vfmsub132_Double bv1 bv2 bv3  = undefined"
|  "BV_ternary_operate BV_Vfnmadd132_Single bv1 bv2 bv3  = undefined"
|  "BV_ternary_operate BV_Vfnmadd132_Double  bv1 bv2 bv3  = undefined"
|  "BV_ternary_operate BV_Vfnmsub132_Single bv1 bv2 bv3  = undefined"
|  "BV_ternary_operate BV_Vnfmsub132_Double bv1 bv2 bv3  = undefined"
|  "BV_ternary_operate BV_Vfmadd132_Single bv1 bv2 bv3  = undefined"
|  "BV_ternary_operate BV_Vfmadd132_Double bv1 bv2 bv3  = undefined"

primrec BV_binary_operate :: "BV_binary_operators \<Rightarrow> bv \<Rightarrow> bv \<Rightarrow> bv"
  where "BV_binary_operate BV_And bv1 bv2 = (let (w1,s1) = bv1;(w2,s2) = bv2 in(((AND) w1 w2), max s1 s2))"
  | "BV_binary_operate BV_Concat bv1 bv2 = bv_cat bv1 bv2"
  | "BV_binary_operate BV_Div bv1 bv2 = undefined"
  | "BV_binary_operate BV_Minus bv1 bv2 = (let (w1,s1) = bv1;(w2,s2) = bv2 in(((-) w1 w2), max s1 s2))"
  | "BV_binary_operate BV_Modulus _ _ = undefined"
  | "BV_binary_operate BV_Mult _ _ = undefined"
  | "BV_binary_operate BV_Or bv1 bv2 = (let (w1,s1) = bv1;(w2,s2) = bv2 in(((OR) w1 w2), max s1 s2))"
  | "BV_binary_operate BV_Plus bv1 bv2 = bv1 +\<^sup>b\<^sup>v bv2"
  | "BV_binary_operate BV_Rot_Left _ _ = undefined"
  | "BV_binary_operate BV_Rot_Right _ _ = undefined"
  | "BV_binary_operate BV_Shift_Left _ _ = undefined"
  | "BV_binary_operate BV_Shift_Right _ _ = undefined"
  | "BV_binary_operate BV_Signed_Div _ _ = undefined"
  | "BV_binary_operate BV_Signed_Mod _ _ = undefined"
  | "BV_binary_operate BV_Sign_Shift_Right _ _ = undefined"
  | "BV_binary_operate BV_Xor bv1 bv2 = (let (w1,s1) = bv1;(w2,s2) = bv2 in(((XOR) w1 w2), max s1 s2))"
  | "BV_binary_operate BV_Cmpf  _ _ = undefined"
  | "BV_binary_operate BV_Cmpd _ _ = undefined"
  | "BV_binary_operate BV_Add_Double bv1 bv2 = bv1 fplus\<^sup>b\<^sup>v bv2"
  | "BV_binary_operate BV_Add_Single _ _ = undefined"
  | "BV_binary_operate BV_Sub_Double bv1 bv2 = bv1 fsub\<^sup>b\<^sup>v bv2"
  | "BV_binary_operate BV_Sub_Single _ _ = undefined"
  | "BV_binary_operate BV_Div_Double bv1 bv2 = bv1 fdiv\<^sup>b\<^sup>v bv2"
  | "BV_binary_operate BV_Div_Single _ _ = undefined"
  | "BV_binary_operate BV_Maxcmp_Double _ _ = undefined"
  | "BV_binary_operate BV_Maxcmp_Single _ _ = undefined"
  | "BV_binary_operate BV_Mincmp_Double _ _ = undefined"
  | "BV_binary_operate BV_Mincmp_Single _ _ = undefined"
  | "BV_binary_operate BV_Mul_Double bv1 bv2 = bv1 fmult\<^sup>b\<^sup>v bv2"
  | "BV_binary_operate BV_Mul_Single _ _ = undefined"
  | "BV_binary_operate BV_Idiv_Quotient_Int8 _ _ = undefined"
  | "BV_binary_operate BV_Idiv_Remainder_Int8 _ _ = undefined"
  | "BV_binary_operate BV_Idiv_Quotient_Int16 _ _ = undefined"
  | "BV_binary_operate BV_Idiv_Remainder_Int16 _ _ = undefined"
  | "BV_binary_operate BV_Idiv_Quotient_Int32 _ _ = undefined"
  | "BV_binary_operate BV_Idiv_Remainder_Int32 _ _ = undefined"
  | "BV_binary_operate BV_Idiv_Quotient_Int64 _ _ = undefined"
  | "BV_binary_operate BV_Idiv_Remainder_Int64 _ _ = undefined"
  | "BV_binary_operate BV_Div_Quotient_Int8 _ _ = undefined"
  | "BV_binary_operate BV_Div_Remainder_Int8 _ _ = undefined"
  | "BV_binary_operate BV_Div_Quotient_Int16 _ _ = undefined"
  | "BV_binary_operate BV_Div_Remainder_Int16 _ _ = undefined"
  | "BV_binary_operate BV_Div_Quotient_Int32 _ _ = undefined"
  | "BV_binary_operate BV_Div_Remainder_Int32 _ _ = undefined"
  | "BV_binary_operate BV_Div_Quotient_Int64 _ _ = undefined"
  | "BV_binary_operate BV_Div_Remainder_Int64  _ _ = undefined"


primrec BV_unary_operate :: "BV_unary_operators \<Rightarrow> bv \<Rightarrow> bv"
  where "BV_unary_operate BV_SExtend16 bv = (let (w,s) = bv in sextend w s 16, 16)"
  | "BV_unary_operate BV_SExtend32 bv = (let (w,s) = bv in sextend w s 32, 32)"
  | "BV_unary_operate BV_SExtend64 bv = (let (w,s) = bv in sextend w s 64, 64)"
  | "BV_unary_operate BV_SExtend128 bv = (let (w,s) = bv in sextend w s 128, 128)"
  | "BV_unary_operate BV_SExtend256 bv = (let (w,s) = bv in sextend w s 256, 256)"
  | "BV_unary_operate BV_Not bv = bv_NOT bv"
  | "BV_unary_operate BV_Neg bv = (let (w,s) = bv in (-w,s))"
  | "BV_unary_operate  BV_Cvt_Int32_To_Double  _ =             undefined" (* 32 \<rightarrow> 64 bit*)
  | "BV_unary_operate BV_Cvt_Single_To_Double  _ =             undefined" (* 32 \<rightarrow> 64 bit*)
  | "BV_unary_operate BV_Cvt_Double_To_Int64  _ =              undefined" (*64 \<rightarrow> 64 bit *)
  | "BV_unary_operate BV_Cvt_Single_To_Int64  _ =              undefined" (* 32 \<rightarrow> 64 bit*)
  | "BV_unary_operate BV_Cvt_Double_To_Int64_Truncate   _ =    undefined" (*64 \<rightarrow> 64 bit *)
  | "BV_unary_operate BV_Cvt_Single_To_Int64_Truncate  _ =     undefined" (* 32 \<rightarrow> 64 bit*)
  | "BV_unary_operate BV_Cvt_Int32_To_Single  _ =              undefined" (* 32 \<rightarrow> 32 bit*)
  | "BV_unary_operate BV_Cvt_Double_To_Int32   _ =             undefined" (*64 \<rightarrow> 32 bit*)
  | "BV_unary_operate BV_Cvt_Double_To_Single  _ =             undefined" (*64 \<rightarrow> 32 bit*)
  | "BV_unary_operate BV_Cvt_Single_To_Int32  _ =              undefined" (* 32 \<rightarrow> 32 bit*)
  | "BV_unary_operate BV_Cvt_Int64_To_Double  _ =              undefined" (*64 \<rightarrow> 64 bit *)
  | "BV_unary_operate BV_Cvt_Int64_To_Single   _ =             undefined" (*64 \<rightarrow> 32 bit*)
  | "BV_unary_operate BV_Cvt_Double_To_Int32_Truncate  _ =     undefined" (*64 \<rightarrow> 32 bit*)
  | "BV_unary_operate BV_Cvt_Single_To_Int32_Truncate  _ =     undefined" (* 32 \<rightarrow> 32 bit*)
  | "BV_unary_operate  BV_Approx_Reciprocal_Single  _ =        undefined"  (* 32 \<rightarrow> 32 bit*)
  | "BV_unary_operate  BV_Approx_Reciprocal_Sqrt_Single  _ =   undefined"  (* 32 \<rightarrow> 32 bit*)
  | "BV_unary_operate  BV_Sqrt_Single  _ =                     undefined"  (* 32 \<rightarrow> 32 bit*)
  | "BV_unary_operate  BV_Sqrt_Double  _ =                     undefined"   (*64 \<rightarrow> 64 bit *)



primrec B_binary_operate :: "B_binary_operators \<Rightarrow> bv \<Rightarrow> bv \<Rightarrow> bv"
  where
    "B_binary_operate B_And bv1 bv2 = bool_to_bv (bv_to_bool bv1 \<and> bv_to_bool bv2)"
  | "B_binary_operate B_Or bv1 bv2 = bool_to_bv (bv_to_bool bv1 \<or> bv_to_bool bv2)"
  | "B_binary_operate B_Xor bv1 bv2 = (let x = bv_to_bool bv1 ; y = bv_to_bool bv2 in
          bool_to_bv ((x \<and> \<not>y) \<or> (\<not>x \<and> y)))"
  | "B_binary_operate B_Iff bv1 bv2 =  bool_to_bv (bv_to_bool bv1 \<longleftrightarrow> bv_to_bool bv2)"
  | "B_binary_operate B_Implies bv1 bv2 = bool_to_bv (bv_to_bool bv1 \<longrightarrow> bv_to_bool bv2)"
  | "B_binary_operate B_Eq bv1 bv2 = bool_to_bv (bv1 = bv2)"

fun positive_offset_address :: "address \<Rightarrow> int \<Rightarrow> address "
  where "positive_offset_address a i = (A_Plus (A_Constant i) a)"

(* Upgrade a general register to its 64-bit parent or a Vector Register to it's 256-bit parent *)
fun operand_get_parent :: "operand_src \<Rightarrow> operand_src"
  where
     "operand_get_parent (Storage (Reg (General _ r)))  =  (Storage (Reg (General SixtyFour r)))" (* Upgrade to full 64-bit register *)
  |  "operand_get_parent (Storage (Reg (SSE w3 w2 w1 w0))) =  (Storage (Reg (AVX w3 w2 w1 w0)))" (* Upgrade to 256-bit register*)
  |  "operand_get_parent operand  =  operand"

(* resolve a parametric or direct variable for reading (and if downgraded to operand_dest with assocated caveat, writing).
 Gives you an operand source vice dest as it's more general. Upgrades where needed to
the operand src from a dest, as well as to parent registers as we operate only on whole registers.
*)
fun resolve_BV_Var :: "instr \<Rightarrow> BV_var \<Rightarrow> operand_src"
  where
    "resolve_BV_Var (Unary _ i) BV_Operand1 = operand_get_parent i"
  | "resolve_BV_Var (Binary _ i _) BV_Operand1 = operand_get_parent (Storage (i))"
  | "resolve_BV_Var (Ternary _ i _ _) BV_Operand1 =operand_get_parent (Storage (i))"
  | "resolve_BV_Var (Binary _ _ i) BV_Operand2 = operand_get_parent i"
  | "resolve_BV_Var (Ternary _ _ i _) BV_Operand2 =operand_get_parent i"
  | "resolve_BV_Var (Ternary _ _ _ i) BV_Operand3 =operand_get_parent i"
  | "resolve_BV_Var _ (BV_Var_Direct r) = (Storage (Reg (General SixtyFour r)))"
  | "resolve_BV_Var _ _ = undefined" (* Nullary's don't have operands. Also for example a Unary doesn't have an operand 2 *)

(* This is needed for BV_Assignment which should never resolve down to writing to an immediate *)
primrec operand_src_to_operand_dest  :: " operand_src \<Rightarrow> operand_dest"
  where
   "operand_src_to_operand_dest (Storage s) = s"
|  "operand_src_to_operand_dest (Immediate s) = undefined"

(* This could be folded into data_from_src, if it were generalized to (longword x bits) and fixed the manual_exec that would be affected *)
fun exec_chum_bv_get :: "state \<Rightarrow> instr \<Rightarrow> operand_src \<Rightarrow> bv"
  where
(* We should never really read a 128-bit register as it'a a partial to the AVX register and gets upgraded when resolved. Regardless it's here. *)
    "exec_chum_bv_get \<sigma> i (Storage (Reg (SSE _ _ high low ))) = ( let
                                                                (w1,s1) =  data_from_src l \<alpha> \<sigma> (Storage (Reg (General SixtyFour high)));
                                                                (w0,s0) =  data_from_src l \<alpha> \<sigma> (Storage (Reg (General SixtyFour low)));
                                                                bv1 = (\<langle>63,0\<rangle> w1,s1);
                                                                bv0 = (\<langle>63,0\<rangle> w0,s0)
                                                                      in bv_cat bv1 bv0)"

  |    "exec_chum_bv_get \<sigma> i (Storage (Reg (AVX word3 word2 word1 word0 ))) = ( let
                                                                (w3,s3) =  data_from_src l \<alpha> \<sigma> (Storage (Reg (General SixtyFour word3)));
                                                                (w2,s2) =  data_from_src l \<alpha> \<sigma> (Storage (Reg (General SixtyFour word2)));
                                                                (w1,s1) =  data_from_src l \<alpha> \<sigma> (Storage (Reg (General SixtyFour word1)));
                                                                (w0,s0) =  data_from_src l \<alpha> \<sigma> (Storage (Reg (General SixtyFour word0)));
                                                                bv3 = (\<langle>63,0\<rangle> w3,s3);
                                                                bv2 = (\<langle>63,0\<rangle> w2,s2);
                                                                bv1 = (\<langle>63,0\<rangle> w1,s1);
                                                                bv0 = (\<langle>63,0\<rangle> w0,s0)
                                                                      in (bv_cat (bv_cat bv3 bv2) (bv_cat bv1 bv0)) )"
  |    "exec_chum_bv_get \<sigma> i (Storage (Memory msize a))  =
              (if (msize = 256)
               then ( let
                        (w3,s3) =  data_from_src l \<alpha> \<sigma> (Storage (Memory 64 (positive_offset_address a 24)));
                        (w2,s2) =  data_from_src l \<alpha> \<sigma> (Storage (Memory 64 (positive_offset_address a 16)));
                        (w1,s1) =  data_from_src l \<alpha> \<sigma> (Storage (Memory 64 (positive_offset_address a 8)));
                        (w0,s0) =  data_from_src l \<alpha> \<sigma> (Storage (Memory 64 a));
                        bv3 = (\<langle>63,0\<rangle> w3,s3);
                        bv2 = (\<langle>63,0\<rangle> w2,s2);
                        bv1 = (\<langle>63,0\<rangle> w1,s1);
                        bv0 = (\<langle>63,0\<rangle> w0,s0)
                      in (bv_cat (bv_cat bv3 bv2) (bv_cat bv1 bv0)) )
               else( if (msize = 128)
                     then ( let
                              (w1,s1) =  data_from_src l \<alpha> \<sigma> (Storage (Memory 64 (positive_offset_address a 8)));
                              (w0,s0) =  data_from_src l \<alpha> \<sigma> (Storage (Memory 64 a));
                              bv1 = (\<langle>63,0\<rangle> w1,s1);
                              bv0 = (\<langle>63,0\<rangle> w0,s0)
                            in bv_cat (0,128) (bv_cat bv1 bv0)) \<comment> \<open>Prefix read with 128-bit zeros as part of generalization condition\<close>
                     else
                        ( let (w,s) = data_from_src l \<alpha> \<sigma> (Storage (Memory msize a)) in (\<langle>63,0\<rangle> w,64) ) \<comment> \<open>Size is always considered 64 as we generalized a memory access to its register eqivalent which gets upgraded to parent register.\<close>
                   )
              )"
| "exec_chum_bv_get \<sigma> i o_src = ( let (w,s) = data_from_src l \<alpha> \<sigma> o_src in (\<langle>63,0\<rangle> w,64) )" (* Handles reading from imm8-imm64, r8-r64 *)

section \<open>The semantics of chum\<close>


primrec exec_chum_bvf :: "bitvector_formula \<Rightarrow> instr \<Rightarrow> state \<Rightarrow> bv"
where
   "exec_chum_bvf (BV_Immediate val bits) i \<sigma> = ((word_of_int val),bits)"
|  "exec_chum_bvf (BV_Get v) insr \<sigma> = (let' vv = resolve_BV_Var insr v; ret = exec_chum_bv_get \<sigma> insr vv in ret)"
|  "exec_chum_bvf (BV_Slice \<psi> hi lo) i \<sigma> = (let' bv = exec_chum_bvf \<psi> i \<sigma> in
                                                  bv_slice hi lo bv)"
| "exec_chum_bvf (BV_Unop ui \<psi>) i \<sigma> =
      (let' bv0 = exec_chum_bvf \<psi> i \<sigma> in
        BV_unary_operate ui bv0)"
| "exec_chum_bvf (BV_Binop bi \<psi>0 \<psi>1) i \<sigma> =
      (let' bv0 = exec_chum_bvf \<psi>0 i \<sigma>;
            bv1 = exec_chum_bvf \<psi>1 i \<sigma> in
        BV_binary_operate bi bv0 bv1)"
| "exec_chum_bvf (BV_Ternop ti \<psi>0 \<psi>1 \<psi>2) i \<sigma> = BV_ternary_operate ti (exec_chum_bvf \<psi>0 i \<sigma>) (exec_chum_bvf \<psi>1 i \<sigma>) (exec_chum_bvf \<psi>2 i \<sigma>)"(* TODO: let' *)
| "exec_chum_bvf (BV_ITE bf \<psi>0 \<psi>1) i \<sigma> = (let' b = bv_to_bool (exec_chum_bvf bf i \<sigma>) in
                                                 if b then exec_chum_bvf \<psi>0 i \<sigma> else exec_chum_bvf \<psi>1 i \<sigma>)"
| "exec_chum_bvf (BV_Assignment a b) i \<sigma> = undefined" (* We should never have a sub-assignment *)
| "exec_chum_bvf (BV_Flag_Assignment a b) i \<sigma> = undefined" (* We should never have a sub-assignment *)
| "exec_chum_bvf (B_Binop bi \<psi>0 \<psi>1) i \<sigma> = B_binary_operate bi (exec_chum_bvf \<psi>0 i \<sigma>) (exec_chum_bvf \<psi>1 i \<sigma>)"
| "exec_chum_bvf (B_Get f) i \<sigma> = (let' f = read_flg \<sigma> f in bool_to_bv f)"
| "exec_chum_bvf (B_True) i \<sigma> = (1,1)"
| "exec_chum_bvf (B_False) i \<sigma> = (0,1)"


type_synonym flag_annotation = "(int \<times> int) \<Rightarrow> flag set"

fun exec_learned_instr :: "flag_annotation \<Rightarrow> bitvector_formula list \<Rightarrow> instr \<Rightarrow> state \<Rightarrow> state"
  where
  "exec_learned_instr \<phi> [] i \<sigma> = \<sigma>"
| "exec_learned_instr \<phi> ((BV_Assignment v bvf)#bfs) i \<sigma> =
    (let' bv  =((exec_chum_bvf bvf i \<sigma>));
          od = operand_src_to_operand_dest (resolve_BV_Var i v);
          \<sigma>' = exec_learned_instr \<phi> bfs i \<sigma> in
      bv_put od bv \<sigma>')"
| "exec_learned_instr \<phi> ((BV_Flag_Assignment flg bvf)#bfs) i \<sigma> =
    (if flg \<in> \<phi> (ts \<sigma>,pc \<sigma>) then
      let' \<sigma>' = exec_learned_instr \<phi> bfs i \<sigma>;
           e  = exec_chum_bvf bvf i \<sigma>;
           f  = bv_to_bool e;
           \<sigma>'' = write_flg flg f \<sigma>' in
        \<sigma>''
    else
      let' \<sigma>' = exec_learned_instr \<phi> bfs i \<sigma>;
           \<sigma>'' = write_flg flg undefined \<sigma>' in
         \<sigma>'')"
| "exec_learned_instr \<phi> _ i \<sigma> = undefined"



definition  init_state :: "state \<Rightarrow> state"
  where "init_state \<sigma> \<equiv> let m = write_blocks (data_sections_to_blocks l (data_sections \<alpha>)) (mem \<sigma>) in \<sigma>\<lparr>mem:=m,pc:=0\<rparr>"


fun exec_instr :: "flag_annotation \<Rightarrow> semantics \<Rightarrow> instr \<Rightarrow> state \<Rightarrow> state"
  where
    "exec_instr \<phi> \<Psi> insr \<sigma> = (
      let' (fam,n,o_sig) = Get_Instr_Sig insr;
           family_list = instr_semantics \<Psi> fam;
           manual = (family_list = None);
           variant_list = (if manual then None else the family_list n);
           manual = (variant_list = None);
           bv_formula = (if manual then None else the variant_list o_sig);
           manual = (bv_formula = None);
           exec = (if manual then manual_exec_instr  insr else exec_learned_instr \<phi> (the bv_formula) insr);
           \<sigma>' = exec \<sigma>;
           \<sigma>'' = (if manual then \<sigma>' else incr_pc \<sigma>') in
        \<sigma>''
     )"

fun exec_assembly :: "flag_annotation \<Rightarrow> semantics \<Rightarrow> nat \<Rightarrow> state \<Rightarrow> state"
  where "exec_assembly _ _ 0 \<sigma> = \<sigma>"
  | "exec_assembly \<phi> \<Psi> (Suc n) \<sigma> = (
    let' t = text_sections \<alpha>!(nat (ts \<sigma>));
         i = instructions t!(nat (pc \<sigma>));
         \<sigma> = exec_instr \<phi> \<Psi> i \<sigma>;
         \<sigma> = exec_assembly \<phi> \<Psi> n \<sigma> in
      \<sigma>
    )"

lemma exec_assembly_def:
  shows "exec_assembly \<phi> \<Psi> n \<sigma> = (if n = 0 then \<sigma> else let' t = text_sections \<alpha> ! (nat (ts \<sigma>)); i = instructions t ! (nat (pc \<sigma>)); \<sigma> = exec_instr \<phi> \<Psi> i \<sigma>; \<sigma> = exec_assembly \<phi> \<Psi> (n-1) \<sigma> in \<sigma>)"
  by (cases n,auto simp add: Let'_def Let_def)
lemmas exec_assembly.simps(2-) [simp del]


lemma compose_exec_assembly:
  assumes "x = y + z"
  shows "exec_assembly \<phi> \<Psi> x \<sigma> = exec_assembly \<phi> \<Psi> y (exec_assembly \<phi> \<Psi> z \<sigma>)"
  using assms
proof(induct \<phi> \<Psi> x \<sigma> arbitrary: y z rule: exec_assembly.induct)
  case (1 \<phi> \<Psi> \<sigma>)
  thus ?case
    by auto
next
  case (2 \<phi> \<Psi> n \<sigma>)
  show ?case
  proof(cases z)
    case 0
    thus ?thesis
      apply (auto simp only: exec_assembly.simps Let'_def Let_def)
      using 2(2) 2(1)[of "y-1" 0 "exec_instr \<phi> \<Psi> (instructions (text_sections \<alpha> ! nat (ts \<sigma>)) ! nat (pc \<sigma>)) \<sigma>"]
      by (auto simp add: exec_assembly.simps(2) Let'_def Let_def)
  next
    case (Suc z')
    thus ?thesis
      apply (auto simp only: exec_assembly.simps Let'_def Let_def)
      using 2(2) 2(1)[of y z' "exec_instr \<phi> \<Psi> (instructions (text_sections \<alpha> ! nat (ts \<sigma>)) ! nat (pc \<sigma>)) \<sigma>"]
      by auto
  qed
qed

end
end
